Index: CKEditor/trunk/_source/plugins/specialchar/dialogs/specialchar.js
===================================================================
--- CKEditor/trunk/_source/plugins/specialchar/dialogs/specialchar.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/specialchar/dialogs/specialchar.js	(revision 6241)
@@ -13,30 +13,4 @@
 		lang = editor.lang.specialChar;
 
-	var insertSpecialChar = function ( specialChar )
-	{
-		var selection = editor.getSelection(),
-			ranges = selection.getRanges( true ),
-			range, textNode;
-
-		editor.fire( 'saveSnapshot' );
-
-		for ( var i = ranges.length - 1; i >= 0 ; i-- )
-		{
-			range = ranges[ i ];
-			range.deleteContents();
-
-			textNode = CKEDITOR.dom.element.createFromHtml( specialChar );
-			range.insertNode( textNode );
-		}
-
-		if ( range )
-		{
-			range.moveToPosition( textNode, CKEDITOR.POSITION_AFTER_END );
-			range.select();
-		}
-
-		editor.fire( 'saveSnapshot' );
-	};
-
 	var onChoice = function( evt )
 	{
@@ -52,9 +26,5 @@
 			dialog.hide();
 
-			// Firefox has bug on insert chars into a element use its own API. (#5170)
-			if ( CKEDITOR.env.gecko )
-				insertSpecialChar( value );
-			else
-				editor.insertHtml( value );
+			editor.insertHtml( value );
 		}
 	};
@@ -223,46 +193,9 @@
 		buttons : [ CKEDITOR.dialog.cancelButton ],
 		charColumns : 17,
-		chars :
-			[
-				'!','&quot;','#','$','%','&amp;',"'",'(',')','*','+','-','.','/',
-				'0','1','2','3','4','5','6','7','8','9',':',';',
-				'&lt;','=','&gt;','?','@',
-				'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
-				'P','Q','R','S','T','U','V','W','X','Y','Z',
-				'[',']','^','_','`',
-				'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p',
-				'q','r','s','t','u','v','w','x','y','z',
-				'{','|','}','~','&euro;(EURO SIGN)','&lsquo;(LEFT SINGLE QUOTATION MARK)','&rsquo;(RIGHT SINGLE QUOTATION MARK)','&ldquo;(LEFT DOUBLE QUOTATION MARK)',
-				'&rdquo;(RIGHT DOUBLE QUOTATION MARK)','&ndash;(EN DASH)','&mdash;(EM DASH)','&iexcl;(INVERTED EXCLAMATION MARK)','&cent;(CENT SIGN)','&pound;(POUND SIGN)',
-				'&curren;(CURRENCY SIGN)','&yen;(YEN SIGN)','&brvbar;(BROKEN BAR)','&sect;(SECTION SIGN)','&uml;(DIAERESIS)','&copy;(COPYRIGHT SIGN)','&ordf;(FEMININE ORDINAL INDICATOR)',
-				'&laquo;(LEFT-POINTING DOUBLE ANGLE QUOTATION MARK)','&not;(NOT SIGN)','&reg;(REGISTERED SIGN)','&macr;(MACRON)','&deg;(DEGREE SIGN)','&plusmn;(PLUS-MINUS SIGN)','&sup2;(SUPERSCRIPT TWO)',
-				'&sup3;(SUPERSCRIPT THREE)','&acute;(ACUTE ACCENT)','&micro;(MICRO SIGN)','&para;(PILCROW SIGN)','&middot;(MIDDLE DOT)','&cedil;(CEDILLA)',
-				'&sup1;(SUPERSCRIPT ONE)','&ordm;(MASCULINE ORDINAL INDICATOR)','&raquo;(RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK)','&frac14;(VULGAR FRACTION ONE QUARTER)','&frac12;(VULGAR FRACTION ONE HALF)','&frac34;(VULGAR FRACTION THREE QUARTERS)',
-				'&iquest;(INVERTED QUESTION MARK)','&Agrave;(LATIN CAPITAL LETTER A WITH GRAVE)','&Aacute;(LATIN CAPITAL LETTER A WITH ACUTE)','&Acirc;(LATIN CAPITAL LETTER A WITH CIRCUMFLEX)','&Atilde;(LATIN CAPITAL LETTER A WITH TILDE)','&Auml;(LATIN CAPITAL LETTER A WITH DIAERESIS)',
-				'&Aring;(LATIN CAPITAL LETTER A WITH RING ABOVE)','&AElig;(LATIN CAPITAL LETTER AE)','&Ccedil;(LATIN CAPITAL LETTER C WITH CEDILLA)','&Egrave;(LATIN CAPITAL LETTER E WITH GRAVE)','&Eacute;(LATIN CAPITAL LETTER E WITH ACUTE)','&Ecirc;(LATIN CAPITAL LETTER E WITH CIRCUMFLEX)',
-				'&Euml;(LATIN CAPITAL LETTER E WITH DIAERESIS)','&Igrave;(LATIN CAPITAL LETTER I WITH GRAVE)','&Iacute;(LATIN CAPITAL LETTER I WITH ACUTE)','&Icirc;(LATIN CAPITAL LETTER I WITH CIRCUMFLEX)','&Iuml;(LATIN CAPITAL LETTER I WITH DIAERESIS)','&ETH;(LATIN CAPITAL LETTER ETH)',
-				'&Ntilde;(LATIN CAPITAL LETTER N WITH TILDE)','&Ograve;(LATIN CAPITAL LETTER O WITH GRAVE)','&Oacute;(LATIN CAPITAL LETTER O WITH ACUTE)','&Ocirc;(LATIN CAPITAL LETTER O WITH CIRCUMFLEX)','&Otilde;(LATIN CAPITAL LETTER O WITH TILDE)','&Ouml;(LATIN CAPITAL LETTER O WITH DIAERESIS)',
-				'&times;(MULTIPLICATION SIGN)','&Oslash;(LATIN CAPITAL LETTER O WITH STROKE)','&Ugrave;(LATIN CAPITAL LETTER U WITH GRAVE)','&Uacute;(LATIN CAPITAL LETTER U WITH ACUTE)','&Ucirc;(LATIN CAPITAL LETTER U WITH CIRCUMFLEX)','&Uuml;(LATIN CAPITAL LETTER U WITH DIAERESIS)',
-				'&Yacute;(LATIN CAPITAL LETTER Y WITH ACUTE)','&THORN;(LATIN CAPITAL LETTER THORN)','&szlig;(LATIN SMALL LETTER SHARP S)','&agrave;(LATIN SMALL LETTER A WITH GRAVE)','&aacute;(LATIN SMALL LETTER A WITH ACUTE)','&acirc;(LATIN SMALL LETTER A WITH CIRCUMFLEX)',
-				'&atilde;(LATIN SMALL LETTER A WITH TILDE)','&auml;(LATIN SMALL LETTER A WITH DIAERESIS)','&aring;(LATIN SMALL LETTER A WITH RING ABOVE)','&aelig;(LATIN SMALL LETTER AE)','&ccedil;(LATIN SMALL LETTER C WITH CEDILLA)','&egrave;(LATIN SMALL LETTER E WITH GRAVE)',
-				'&eacute;(LATIN SMALL LETTER E WITH ACUTE)','&ecirc;(LATIN SMALL LETTER E WITH CIRCUMFLEX)','&euml;(LATIN SMALL LETTER E WITH DIAERESIS)','&igrave;(LATIN SMALL LETTER I WITH GRAVE)','&iacute;(LATIN SMALL LETTER I WITH ACUTE)','&icirc;(LATIN SMALL LETTER I WITH CIRCUMFLEX)',
-				'&iuml;(LATIN SMALL LETTER I WITH DIAERESIS)','&eth;(LATIN SMALL LETTER ETH)','&ntilde;(LATIN SMALL LETTER N WITH TILDE)','&ograve;(LATIN SMALL LETTER O WITH GRAVE)','&oacute;(LATIN SMALL LETTER O WITH ACUTE)','&ocirc;(LATIN SMALL LETTER O WITH CIRCUMFLEX)',
-				'&otilde;(LATIN SMALL LETTER O WITH TILDE)','&ouml;(LATIN SMALL LETTER O WITH DIAERESIS)',
-				'&divide;(DIVISION SIGN)','&oslash;(LATIN SMALL LETTER O WITH STROKE)',
-				'&ugrave;(LATIN SMALL LETTER U WITH GRAVE)','&uacute;(LATIN SMALL LETTER U WITH ACUTE)',
-				'&ucirc;(LATIN SMALL LETTER U WITH CIRCUMFLEX)','&uuml;(LATIN SMALL LETTER U WITH DIAERESIS)',
-				'&uuml;(LATIN SMALL LETTER U WITH DIAERESIS)','&yacute;(LATIN SMALL LETTER Y WITH ACUTE)','&thorn;(LATIN SMALL LETTER THORN)','&yuml;(LATIN SMALL LETTER Y WITH DIAERESIS)',
-				'&OElig;(LATIN CAPITAL LIGATURE OE)',
-				'&oelig;(LATIN SMALL LIGATURE OE)','&#372;(LATIN CAPITAL LETTER W WITH CIRCUMFLEX)',
-				'&#374(LATIN CAPITAL LETTER Y WITH CIRCUMFLEX)','&#373(LATIN SMALL LETTER W WITH CIRCUMFLEX)',
-				'&#375;(LATIN SMALL LETTER Y WITH CIRCUMFLEX)','&sbquo;(SINGLE LOW-9 QUOTATION MARK)',
-				'&#8219;(SINGLE HIGH-REVERSED-9 QUOTATION MARK)','&bdquo;(DOUBLE LOW-9 QUOTATION MARK)','&hellip;(HORIZONTAL ELLIPSIS)',
-				'&trade;(TRADE MARK SIGN)','&#9658;(BLACK RIGHT-POINTING POINTER)','&bull;(BULLET)',
-				'&rarr;(RIGHTWARDS ARROW)','&rArr;(RIGHTWARDS DOUBLE ARROW)','&hArr;(LEFT RIGHT DOUBLE ARROW)','&diams;(BLACK DIAMOND SUIT)','&asymp;(ALMOST EQUAL TO)'
-			],
 		onLoad :  function()
 		{
 			var columns = this.definition.charColumns,
-				chars = this.definition.chars;
+				extraChars = editor.config.extraSpecialChars,
+				chars = editor.config.specialChars;
 
 			var charsTableLabel =  CKEDITOR.tools.getNextId() + '_specialchar_table_label';
@@ -285,12 +218,17 @@
 					{
 						charDesc = '';
-						character = character.replace( /\((.*?)\)/, function( match, desc )
-							{
-								charDesc = desc;
-								return '';
-							} );
-
-						// Use character in case description unavailable.
-						charDesc = charDesc || character;
+
+						if ( character instanceof Array )
+						{
+							charDesc = character[ 1 ];
+							character = character[ 0 ];
+						}
+						else
+						{
+							var _tmpName = character.toLowerCase().replace( '&', '' ).replace( ';', '' ).replace( '#', '' );
+
+							// Use character in case description unavailable.
+							charDesc = lang[ _tmpName ] || character;
+						}
 
 						var charLabelId =  'cke_specialchar_label_' + i + '_' + CKEDITOR.tools.getNextNumber();
Index: CKEditor/trunk/_source/plugins/specialchar/lang/en.js
===================================================================
--- CKEditor/trunk/_source/plugins/specialchar/lang/en.js	(revision 6241)
+++ CKEditor/trunk/_source/plugins/specialchar/lang/en.js	(revision 6241)
@@ -0,0 +1,89 @@
+﻿
+CKEDITOR.plugins.setLang( 'specialchar', 'en',
+{
+	euro: "EURO SIGN",
+	lsquo: "LEFT SINGLE QUOTATION MARK",
+	rsquo: "RIGHT SINGLE QUOTATION MARK",
+	ldquo: "LEFT DOUBLE QUOTATION MARK",
+	rdquo: "RIGHT DOUBLE QUOTATION MARK",
+	ndash: "EN DASH",
+	mdash: "EM DASH",
+	iexcl: "INVERTED EXCLAMATION MARK",
+	cent: "CENT SIGN",
+	pound: "POUND SIGN",
+	curren: "CURRENCY SIGN",
+	yen: "YEN SIGN",
+	brvbar: "BROKEN BAR",
+	sect: "SECTION SIGN",
+	uml: "DIAERESIS",
+	copy: "COPYRIGHT SIGN",
+	ordf: "FEMININE ORDINAL INDICATOR",
+	laquo: "LEFT-POINTING DOUBLE ANGLE QUOTATION MARK",
+	not: "NOT SIGN",
+	reg: "REGISTERED SIGN",
+	macr: "MACRON",
+	deg: "DEGREE SIGN",
+	sup2: "SUPERSCRIPT TWO",
+	sup3: "SUPERSCRIPT THREE",
+	acute: "ACUTE ACCENT",
+	micro: "MICRO SIGN",
+	para: "PILCROW SIGN",
+	middot: "MIDDLE DOT",
+	cedil: "CEDILLA",
+	sup1: "SUPERSCRIPT ONE",
+	ordm: "MASCULINE ORDINAL INDICATOR",
+	frac14: "VULGAR FRACTION ONE QUARTER",
+	frac12: "VULGAR FRACTION ONE HALF",
+	frac34: "VULGAR FRACTION THREE QUARTERS",
+	iquest: "INVERTED QUESTION MARK",
+	agrave: "LATIN SMALL LETTER A WITH GRAVE",
+	aacute: "LATIN SMALL LETTER A WITH ACUTE",
+	acirc: "LATIN SMALL LETTER A WITH CIRCUMFLEX",
+	atilde: "LATIN SMALL LETTER A WITH TILDE",
+	auml: "LATIN SMALL LETTER A WITH DIAERESIS",
+	aring: "LATIN SMALL LETTER A WITH RING ABOVE",
+	aelig: "LATIN SMALL LETTER AE",
+	ccedil: "LATIN SMALL LETTER C WITH CEDILLA",
+	egrave: "LATIN SMALL LETTER E WITH GRAVE",
+	eacute: "LATIN SMALL LETTER E WITH ACUTE",
+	ecirc: "LATIN SMALL LETTER E WITH CIRCUMFLEX",
+	euml: "LATIN SMALL LETTER E WITH DIAERESIS",
+	igrave: "LATIN SMALL LETTER I WITH GRAVE",
+	iacute: "LATIN SMALL LETTER I WITH ACUTE",
+	icirc: "LATIN SMALL LETTER I WITH CIRCUMFLEX",
+	iuml: "LATIN SMALL LETTER I WITH DIAERESIS",
+	eth: "LATIN SMALL LETTER ETH",
+	ntilde: "LATIN SMALL LETTER N WITH TILDE",
+	ograve: "LATIN SMALL LETTER O WITH GRAVE",
+	oacute: "LATIN SMALL LETTER O WITH ACUTE",
+	ocirc: "LATIN SMALL LETTER O WITH CIRCUMFLEX",
+	otilde: "LATIN SMALL LETTER O WITH TILDE",
+	ouml: "LATIN SMALL LETTER O WITH DIAERESIS",
+	times: "MULTIPLICATION SIGN",
+	oslash: "LATIN SMALL LETTER O WITH STROKE",
+	ugrave: "LATIN SMALL LETTER U WITH GRAVE",
+	uacute: "LATIN SMALL LETTER U WITH ACUTE",
+	ucirc: "LATIN SMALL LETTER U WITH CIRCUMFLEX",
+	uuml: "LATIN SMALL LETTER U WITH DIAERESIS",
+	yacute: "LATIN SMALL LETTER Y WITH ACUTE",
+	thorn: "LATIN SMALL LETTER THORN",
+	szlig: "LATIN SMALL LETTER SHARP S",
+	divide: "DIVISION SIGN",
+	yuml: "LATIN SMALL LETTER Y WITH DIAERESIS",
+	oelig: "LATIN SMALL LIGATURE OE",
+	'372': "LATIN CAPITAL LETTER W WITH CIRCUMFLEX",
+	'374': "LATIN CAPITAL LETTER Y WITH CIRCUMFLEX",
+	'373': "LATIN SMALL LETTER W WITH CIRCUMFLEX",
+	'375': "LATIN SMALL LETTER Y WITH CIRCUMFLEX",
+	8219: "SINGLE HIGH-REVERSED-9 QUOTATION MARK",
+	bdquo: "DOUBLE LOW-9 QUOTATION MARK",
+	hellip: "HORIZONTAL ELLIPSIS",
+	trade: "TRADE MARK SIGN",
+	'9658': "BLACK RIGHT-POINTING POINTER",
+	bull: "BULLET",
+	rarr: "RIGHTWARDS DOUBLE ARROW",
+	harr: "LEFT RIGHT DOUBLE ARROW",
+	diams: "BLACK DIAMOND SUIT",
+	asymp: "ALMOST EQUAL TO",
+	sbquo: 'SINGLE LOW-9 QUOTATION MARK'
+});
Index: CKEditor/trunk/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/styles/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/styles/plugin.js	(revision 6241)
@@ -6,5 +6,15 @@
 CKEDITOR.plugins.add( 'styles',
 {
-	requires : [ 'selection' ]
+	requires : [ 'selection' ],
+	init : function( editor )
+	{
+		// This doesn't look like correct, but it's the safest way to proper
+		// pass the disableReadonlyStyling configuration to the style system
+		// without having to change any method signature in the API. (#6103)
+		editor.on( 'contentDom', function()
+			{
+				editor.document.setCustomData( 'cke_includeReadonly', !editor.config.disableReadonlyStyling );
+			});
+	}
 });
 
@@ -354,4 +364,33 @@
 	};
 
+	// Gets the parent element which blocks the styling for an element. This
+	// can be done through read-only elements (contenteditable=false) or
+	// elements with the "data-cke-nostyle" attribute.
+	function getUnstylableParent( element )
+	{
+		var unstylable,
+			editable;
+
+		while ( ( element = element.getParent() ) )
+		{
+			if ( element.getName() == 'body' )
+				break;
+
+			if ( element.getAttribute( 'data-cke-nostyle' ) )
+				unstylable = element;
+			else if ( !editable )
+			{
+				var contentEditable = element.getAttribute( 'contentEditable' );
+
+				if ( contentEditable == 'false' )
+					unstylable = element;
+				else if ( contentEditable == 'true' )
+					editable = 1;
+			}
+		}
+
+		return unstylable;
+	}
+
 	function applyInlineStyle( range )
 	{
@@ -375,4 +414,12 @@
 		var def = this._.definition;
 		var isUnknownElement;
+
+		// Indicates that fully selected read-only elements are to be included in the styling range.
+		var includeReadonly = def.includeReadonly;
+
+		// If the read-only inclusion is not available in the definition, try
+		// to get it from the document data.
+		if ( includeReadonly == undefined )
+			includeReadonly = document.getCustomData( 'cke_includeReadonly' );
 
 		// Get the DTD definition for the element. Defaults to "span".
@@ -393,4 +440,22 @@
 		var styleRange;
 
+		// Check if the boundaries are inside non stylable elements.
+		var firstUnstylable = getUnstylableParent( firstNode ),
+			lastUnstylable = getUnstylableParent( lastNode );
+
+		// If the first element can't be styled, we'll start processing right
+		// after its unstylable root.
+		if ( firstUnstylable )
+			currentNode = firstUnstylable.getNextSourceNode( true );
+
+		// If the last element can't be styled, we'll stop processing on its
+		// unstylable root.
+		if ( lastUnstylable )
+			lastNode = lastUnstylable;
+
+		// Do nothing if the current node now follows the last node to be processed.
+		if ( currentNode.getPosition( lastNode ) == CKEDITOR.POSITION_FOLLOWING )
+			currentNode = 0;
+
 		while ( currentNode )
 		{
@@ -406,6 +471,8 @@
 				var nodeType = currentNode.type;
 				var nodeName = nodeType == CKEDITOR.NODE_ELEMENT ? currentNode.getName() : null;
-
-				if ( nodeName && currentNode.getAttribute( '_cke_bookmark' ) )
+				var nodeIsReadonly = nodeName && ( currentNode.getAttribute( 'contentEditable' ) == 'false' );
+				var nodeIsNoStyle = nodeName && currentNode.getAttribute( 'data-cke-nostyle' );
+
+				if ( nodeName && currentNode.data( 'cke-bookmark' ) )
 				{
 					currentNode = currentNode.getNextSourceNode( true );
@@ -415,4 +482,6 @@
 				// Check if the current node can be a child of the style element.
 				if ( !nodeName || ( dtd[ nodeName ]
+					&& !nodeIsNoStyle
+					&& ( !nodeIsReadonly || includeReadonly )
 					&& ( currentNode.getPosition( lastNode ) | CKEDITOR.POSITION_PRECEDING | CKEDITOR.POSITION_IDENTICAL | CKEDITOR.POSITION_IS_CONTAINED ) == ( CKEDITOR.POSITION_PRECEDING + CKEDITOR.POSITION_IDENTICAL + CKEDITOR.POSITION_IS_CONTAINED )
 					&& ( !def.childRule || def.childRule( currentNode ) ) ) )
@@ -436,7 +505,7 @@
 						}
 
-						// Non element nodes, or empty elements can be added
-						// completely to the range.
-						if ( nodeType == CKEDITOR.NODE_TEXT || ( nodeType == CKEDITOR.NODE_ELEMENT && !currentNode.getChildCount() ) )
+						// Non element nodes, readonly elements, or empty
+						// elements can be added completely to the range.
+						if ( nodeType == CKEDITOR.NODE_TEXT || nodeIsReadonly || ( nodeType == CKEDITOR.NODE_ELEMENT && !currentNode.getChildCount() ) )
 						{
 							var includedNode = currentNode;
@@ -462,5 +531,4 @@
 							if ( !includedNode.$.nextSibling )
 								applyStyle = true;
-
 						}
 					}
@@ -472,5 +540,5 @@
 
 				// Get the next node to be processed.
-				currentNode = currentNode.getNextSourceNode();
+				currentNode = currentNode.getNextSourceNode( nodeIsNoStyle || nodeIsReadonly );
 			}
 
@@ -884,5 +952,5 @@
 		// Exclude the ones at header OR at tail,
 		// and ignore bookmark content between them.
-		var duoBrRegex = /(\S\s*)\n(?:\s|(<span[^>]+_cke_bookmark.*?\/span>))*\n(?!$)/gi,
+		var duoBrRegex = /(\S\s*)\n(?:\s|(<span[^>]+data-cke-bookmark.*?\/span>))*\n(?!$)/gi,
 			blockName = preBlock.getName(),
 			splitedHtml = replace( preBlock.getOuterHtml(),
@@ -906,5 +974,5 @@
 			tailBookmark = '';
 
-		str = str.replace( /(^<span[^>]+_cke_bookmark.*?\/span>)|(<span[^>]+_cke_bookmark.*?\/span>$)/gi,
+		str = str.replace( /(^<span[^>]+data-cke-bookmark.*?\/span>)|(<span[^>]+data-cke-bookmark.*?\/span>$)/gi,
 			function( str, m1, m2 ){
 					m1 && ( headBookmark = m1 );
@@ -1356,5 +1424,5 @@
 			// Bookmark the range so we can re-select it after processing.
 			bookmarks = selection.createBookmarks( 1 ),
-			ranges = selection.getRanges( 1 ),
+			ranges = selection.getRanges(),
 			func = remove ? this.removeFromRange : this.applyToRange,
 			range;
@@ -1448,4 +1516,21 @@
 		callback( this._.stylesDefinitions );
 };
+
+/**
+ * Indicates that fully selected read-only elements will be included when
+ * applying the style (for inline styles only).
+ * @name CKEDITOR.style.includeReadonly
+ * @type Boolean
+ * @default false
+ * @since 3.5
+ */
+
+ /**
+  * Disables inline styling on read-only elements.
+  * @name CKEDITOR.config.disableReadonlyStyling
+  * @type Boolean
+  * @default false
+  * @since 3.5
+  */
 
 /**
Index: CKEditor/trunk/_source/plugins/table/dialogs/table.js
===================================================================
--- CKEditor/trunk/_source/plugins/table/dialogs/table.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/table/dialogs/table.js	(revision 6241)
@@ -168,5 +168,5 @@
 							var th = theRow.getChild( i );
 							// Skip bookmark nodes. (#6155)
-							if ( th.type == CKEDITOR.NODE_ELEMENT && !th.hasAttribute( '_cke_bookmark' ) )
+							if ( th.type == CKEDITOR.NODE_ELEMENT && !th.data( 'cke-bookmark' ) )
 							{
 								th.renameNode( 'th' );
@@ -388,11 +388,11 @@
 											type : 'select',
 											'default' : '',
-											label : editor.lang.table.align,
+											label : editor.lang.common.align,
 											items :
 											[
 												[ editor.lang.common.notSet , ''],
-												[ editor.lang.table.alignLeft , 'left'],
-												[ editor.lang.table.alignCenter , 'center'],
-												[ editor.lang.table.alignRight , 'right']
+												[ editor.lang.common.alignLeft , 'left'],
+												[ editor.lang.common.alignCenter , 'center'],
+												[ editor.lang.common.alignRight , 'right']
 											],
 											setup : function( selectedTable )
@@ -424,5 +424,5 @@
 													id : 'txtWidth',
 													style : 'width:5em',
-													label : editor.lang.table.width,
+													label : editor.lang.common.width,
 													'default' : 500,
 													validate : CKEDITOR.dialog.validate['number']( editor.lang.table.invalidWidth ),
@@ -498,5 +498,5 @@
 													id : 'txtHeight',
 													style : 'width:5em',
-													label : editor.lang.table.height,
+													label : editor.lang.common.height,
 													'default' : '',
 													validate : CKEDITOR.dialog.validate['number']( editor.lang.table.invalidHeight ),
Index: CKEditor/trunk/_source/plugins/tableresize/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/tableresize/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/tableresize/plugin.js	(revision 6241)
@@ -299,5 +299,5 @@
 
 		resizer = CKEDITOR.dom.element.createFromHtml(
-			'<div cke_temp=1 contenteditable=false unselectable=on '+
+			'<div data-cke-temp=1 contenteditable=false unselectable=on '+
 			'style="position:absolute;cursor:col-resize;filter:alpha(opacity=0);opacity:0;' +
 				'padding:0;background-color:#004;background-image:none;border:0px none;z-index:10"></div>', document );
Index: CKEditor/trunk/_source/plugins/tabletools/dialogs/tableCell.js
===================================================================
--- CKEditor/trunk/_source/plugins/tabletools/dialogs/tableCell.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/tabletools/dialogs/tableCell.js	(revision 6241)
@@ -13,5 +13,6 @@
 			heightPattern = /^(\d+(?:\.\d+)?)px$/,
 			bind = CKEDITOR.tools.bind,
-			spacer = { type : 'html', html : '&nbsp;' };
+			spacer = { type : 'html', html : '&nbsp;' },
+			rtl = editor.lang.dir == 'rtl';
 
 		/**
@@ -72,6 +73,6 @@
 		return {
 			title : langCell.title,
-			minWidth : CKEDITOR.env.ie && CKEDITOR.env.quirks ? 550 : 480,
-			minHeight : CKEDITOR.env.ie ? ( CKEDITOR.env.quirks ? 180 : 150 ) : 140,
+			minWidth : CKEDITOR.env.ie && CKEDITOR.env.quirks? 450 : 410,
+			minHeight : CKEDITOR.env.ie && CKEDITOR.env.quirks?  230 : 200,
 			contents : [
 				{
@@ -99,7 +100,6 @@
 													type : 'text',
 													id : 'width',
-													label : langTable.width,
-													widths : [ '71%', '29%' ],
-													labelLayout : 'horizontal',
+													width: '100px',
+													label : langCommon.width,
 													validate : validate[ 'number' ]( langCell.invalidWidth ),
 
@@ -140,8 +140,6 @@
 													type : 'select',
 													id : 'widthType',
-													labelLayout : 'horizontal',
-													widths : [ '0%', '100%' ],
 													label : editor.lang.table.widthUnit,
-													labelStyle: 'display:none',
+													labelStyle: 'visibility:hidden',
 													'default' : 'px',
 													items :
@@ -167,8 +165,7 @@
 													type : 'text',
 													id : 'height',
-													label : langTable.height,
+													label : langCommon.height,
+													width: '100px',
 													'default' : '',
-													widths : [ '71%', '29%' ],
-													labelLayout : 'horizontal',
 													validate : validate[ 'number' ]( langCell.invalidHeight ),
 
@@ -207,5 +204,5 @@
 													id : 'htmlHeightType',
 													type : 'html',
-													html : langTable.widthPx
+													html : '<br />'+ langTable.widthPx
 												}
 											]
@@ -215,7 +212,5 @@
 											type : 'select',
 											id : 'wordWrap',
-											labelLayout : 'horizontal',
 											label : langCell.wordWrap,
-											widths : [ '50%', '50%' ],
 											'default' : 'yes',
 											items :
@@ -246,14 +241,12 @@
 											type : 'select',
 											id : 'hAlign',
-											labelLayout : 'horizontal',
 											label : langCell.hAlign,
-											widths : [ '50%', '50%' ],
 											'default' : '',
 											items :
 											[
 												[ langCommon.notSet, '' ],
-												[ langTable.alignLeft, 'left' ],
-												[ langTable.alignCenter, 'center' ],
-												[ langTable.alignRight, 'right' ]
+												[ langCommon.alignLeft, 'left' ],
+												[ langCommon.alignCenter, 'center' ],
+												[ langCommon.alignRight, 'right' ]
 											],
 											setup : function( element )
@@ -279,14 +272,12 @@
 											type : 'select',
 											id : 'vAlign',
-											labelLayout : 'horizontal',
 											label : langCell.vAlign,
-											widths : [ '50%', '50%' ],
 											'default' : '',
 											items :
 											[
 												[ langCommon.notSet, '' ],
-												[ langCell.alignTop, 'top' ],
-												[ langCell.alignMiddle, 'middle' ],
-												[ langCell.alignBottom, 'bottom' ],
+												[ langCommon.alignTop, 'top' ],
+												[ langCommon.alignMiddle, 'middle' ],
+												[ langCommon.alignBottom, 'bottom' ],
 												[ langCell.alignBaseline, 'baseline' ]
 											],
@@ -334,6 +325,4 @@
 											id : 'cellType',
 											label : langCell.cellType,
-											labelLayout : 'horizontal',
-											widths : [ '50%', '50%' ],
 											'default' : 'td',
 											items :
@@ -356,6 +345,4 @@
 											id : 'rowSpan',
 											label : langCell.rowSpan,
-											labelLayout : 'horizontal',
-											widths : [ '50%', '50%' ],
 											'default' : '',
 											validate : validate.integer( langCell.invalidRowSpan ),
@@ -379,6 +366,4 @@
 											id : 'colSpan',
 											label : langCell.colSpan,
-											labelLayout : 'horizontal',
-											widths : [ '50%', '50%' ],
 											'default' : '',
 											validate : validate.integer( langCell.invalidColSpan ),
@@ -402,5 +387,5 @@
 											type : 'hbox',
 											padding : 0,
-											widths : [ '80%', '20%' ],
+											widths : [ '60%', '40%' ],
 											children :
 											[
@@ -409,6 +394,4 @@
 													id : 'bgColor',
 													label : langCell.bgColor,
-													labelLayout : 'horizontal',
-													widths : [ '70%', '30%' ],
 													'default' : '',
 													setup : function( element )
@@ -434,6 +417,11 @@
 													type : 'button',
 													id : 'bgColorChoose',
+													"class" : 'colorChooser',
 													label : langCell.chooseColor,
-													style : 'margin-left: 10px',
+													onLoad : function()
+													{
+														// Stick the element to the bottom (#5587)
+														this.getElement().getParent().setStyle( 'vertical-align', 'bottom' );
+													},
 													onClick : function()
 													{
@@ -453,5 +441,5 @@
 											type : 'hbox',
 											padding : 0,
-											widths : [ '80%', '20%' ],
+											widths : [ '60%', '40%' ],
 											children :
 											[
@@ -460,6 +448,4 @@
 													id : 'borderColor',
 													label : langCell.borderColor,
-													labelLayout : 'horizontal',
-													widths : [ '70%', '30%' ],
 													'default' : '',
 													setup : function( element )
@@ -484,6 +470,12 @@
 													type : 'button',
 													id : 'borderColorChoose',
+													"class" : 'colorChooser',
 													label : langCell.chooseColor,
-													style : 'margin-left: 10px',
+													style : ( rtl ? 'margin-right' : 'margin-left' ) + ': 10px',
+													onLoad : function()
+													{
+														// Stick the element to the bottom (#5587)
+														this.getElement().getParent().setStyle( 'vertical-align', 'bottom' );
+													},
 													onClick : function()
 													{
Index: CKEditor/trunk/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 6241)
@@ -44,6 +44,7 @@
 					editor.toolbox.focusCommandExecuted = true;
 
-					// Make the first button focus accessible. (#3417)
-					if ( CKEDITOR.env.ie )
+					// Make the first button focus accessible for IE. (#3417)
+					// Adobe AIR instead need while of delay.
+					if ( CKEDITOR.env.ie || CKEDITOR.env.air )
 						setTimeout( function(){ editor.toolbox.focus(); }, 100 );
 					else
@@ -418,5 +419,5 @@
  *     ['BidiLtr', 'BidiRtl' ],
  *     ['Link','Unlink','Anchor'],
- *     ['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak'],
+ *     ['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe'],
  *     '/',
  *     ['Styles','Format','Font','FontSize'],
@@ -437,5 +438,5 @@
 	['BidiLtr', 'BidiRtl' ],
 	['Link','Unlink','Anchor'],
-	['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak'],
+	['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe'],
 	'/',
 	['Styles','Format','Font','FontSize'],
Index: CKEditor/trunk/_source/plugins/undo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/undo/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/undo/plugin.js	(revision 6241)
@@ -153,5 +153,5 @@
 
 		// In IE, we need to remove the expando attributes.
-		CKEDITOR.env.ie && contents && ( contents = contents.replace( /\s+_cke_expando=".*?"/g, '' ) );
+		CKEDITOR.env.ie && contents && ( contents = contents.replace( /\s+data-cke-expando=".*?"/g, '' ) );
 
 		this.contents	= contents;
@@ -268,5 +268,5 @@
 						// In IE, we need to remove the expando attributes.
 						if ( CKEDITOR.env.ie )
-							currentSnapshot = currentSnapshot.replace( /\s+_cke_expando=".*?"/g, '' );
+							currentSnapshot = currentSnapshot.replace( /\s+data-cke-expando=".*?"/g, '' );
 
 						if ( beforeTypeImage.contents != currentSnapshot )
Index: CKEditor/trunk/_source/plugins/wsc/dialogs/wsc.js
===================================================================
--- CKEditor/trunk/_source/plugins/wsc/dialogs/wsc.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/wsc/dialogs/wsc.js	(revision 6241)
@@ -180,8 +180,12 @@
 {
 	var data = evt.data,
-		dialog = data.dialog,
-		height = data.height;
+		dialog = data.dialog;
+
+	if ( dialog._.name == 'checkspell' )
+	{
 		var content = dialog.getContentElement( 'general', 'content' ).getElement(),
-				iframe = content && content.getChild( 2 );
-		iframe && iframe.setStyle( 'height', height + 'px' );
+			iframe = content && content.getChild( 2 );
+
+		iframe && iframe.setStyle( 'height', data.height + 'px' );
+	}
 });
Index: CKEditor/trunk/_source/plugins/wsc/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/wsc/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/wsc/plugin.js	(revision 6241)
@@ -19,5 +19,5 @@
 
 		// SpellChecker doesn't work in Opera and with custom domain
-		command.modes = { wysiwyg : ( !CKEDITOR.env.opera && document.domain == window.location.hostname ) };
+		command.modes = { wysiwyg : ( !CKEDITOR.env.opera && !CKEDITOR.env.air && document.domain == window.location.hostname ) };
 
 		editor.ui.addButton( 'SpellChecker',
